program std_call_to_c28
  
  parameter (NTOKENS=2063592,MAX22=4194304)
  character*6 call_std
  character a1*37,a2*36,a3*10,a4*27
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   std_call_to_c28 <call_std>'
     print*,'Example: std_call_to_c28 K1ABC'
     go to 999
  endif
  call getarg(1,call_std)
  call_std=adjustr(call_std)
  i1=index(a1,call_std(1:1))-1
  i2=index(a2,call_std(2:2))-1
  i3=index(a3,call_std(3:3))-1
  i4=index(a4,call_std(4:4))-1
  i5=index(a4,call_std(5:5))-1
  i6=index(a4,call_std(6:6))-1
  n28=NTOKENS + MAX22 + 36*10*27*27*27*i1 + 10*27*27*27*i2 + &
       27*27*27*i3 + 27*27*i4 + 27*i5 + i6

  write(*,1000) call_std,n28
1000 format('Callsign: ',a6,2x,'c28 as decimal integer:',i10)
  
999 end program std_call_to_c28

program grid6_to_g25

  parameter (MAXGRID4=32400)
  character*6 w,grid6
  character c1*1,c2*2
  logical is_grid6

  is_grid6(grid6)=len(trim(grid6)).eq.6 .and.                        &
       grid6(1:1).ge.'A' .and. grid6(1:1).le.'R' .and.               &
       grid6(2:2).ge.'A' .and. grid6(2:2).le.'R' .and.               &
       grid6(3:3).ge.'0' .and. grid6(3:3).le.'9' .and.               &
       grid6(4:4).ge.'0' .and. grid6(4:4).le.'9' .and.               &
       grid6(5:5).ge.'A' .and. grid6(5:5).le.'X' .and.               &
       grid6(6:6).ge.'A' .and. grid6(6:6).le.'X'
  
  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Convert a 6-character grid to a g25 value.'
     print*,'Usage: grid6_to_g25 IO91NP'
     go to 999
  endif
  call getarg(1,w)
  if(.not. is_grid6(w)) go to 900
  
  j1=(ichar(w(1:1))-ichar('A'))*18*10*10*24*24
  j2=(ichar(w(2:2))-ichar('A'))*10*10*24*24
  j3=(ichar(w(3:3))-ichar('0'))*10*24*24
  j4=(ichar(w(4:4))-ichar('0'))*24*24
  j5=(ichar(w(5:5))-ichar('A'))*24
  j6=(ichar(w(6:6))-ichar('A'))
  igrid6=j1+j2+j3+j4+j5+j6

  write(*,1000) w,igrid6,igrid6
1000 format('Encoded word: ',a6,'    g25 in binary: ',b25.25/     &
          30x,'decimal:',i9)
  go to 999

900 write(*,1900)
1900 format('Invalid input')

999 end program grid6_to_g25

program nonstd_to_c58
  
  integer*8 n58
  character*11 callsign
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:    nonstd_to_c58 <callsign>'
     print*,'Examples: nonstd_to_c58 PJ4/K1ABC'
     print*,'          nonstd_to_c58 YW18FIFA'
     go to 999
  endif
  call getarg(1,callsign)

  n58=0
  do i=1,11
     n58=n58*38 + index(c,callsign(i:i)) - 1
  enddo
  write(*,1000) callsign,n58,n58
1000 format('Callsign: ',a11/'c58 (binary):   ' b58.58/'c58 (decimal):',i20)
  
999 end program nonstd_to_c58

program free_text_to_f71

  character*13 c13,w
  character*71 f71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   free_text_to_f71 "<message>"'
     print*,'Example: free_text_to_f71 "TNX BOB 73 GL"'
     go to 999
  endif
  call getarg(1,c13)
  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)    !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo
  write(f71,1000) qa(2:10)
1000 format(b7.7,8b8.8)
  write(*,1010) c13,f71
1010 format('Free text: ',a13/'f71: ',a71)

999 end program free_text_to_f71

subroutine mp_short_ops(w,u)
! Multi-precision arithmetic with storage in character arrays.  
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  return
end subroutine mp_short_ops

program grid4_to_g15

  parameter (MAXGRID4=32400)
  character*4 w,grid4
  character c1*1,c2*2
  logical is_grid4
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Convert a 4-character grid, signal report, etc., to a g15 value.'
     print*,'Usage examples:'
     print*,'grid4_to_g15 FN20'
     print*,'grid4_to_g15 -11'
     print*,'grid4_to_g15 +02'
     print*,'grid4_to_g15 RRR'
     print*,'grid4_to_g15 RR73'
     print*,'grid4_to_g15 73'
     print*,'grid4_to_g15 ""'
     go to 999
  endif
  call getarg(1,w)
  if(is_grid4(w) .and. w.ne.'RR73') then
     j1=(ichar(w(1:1))-ichar('A'))*18*10*10
     j2=(ichar(w(2:2))-ichar('A'))*10*10
     j3=(ichar(w(3:3))-ichar('0'))*10
     j4=(ichar(w(4:4))-ichar('0'))
     igrid4=j1+j2+j3+j4     
  else
     c1=w(1:1)
     if(c1.ne.'+' .and. c1.ne.'-'.and. trim(w).ne.'RRR' .and. w.ne.'RR73' &
          .and. trim(w).ne.'73' .and. len(trim(w)).ne.0) go to 900
     if(c1.eq.'+' .or. c1.eq.'-') then
        read(w,*,err=900) irpt
        irpt=irpt+35
     endif
     if(len(trim(w)).eq.0) irpt=1
     if(trim(w).eq.'RRR') irpt=2
     if(w.eq.'RR73') irpt=3
     if(trim(w).eq.'73') irpt=4
     igrid4=MAXGRID4 + irpt
  endif

  write(*,1000) w,igrid4,igrid4
1000 format('Encoded word: ',a4,'   g15 in binary: ',b15.15,'   decimal:',i6)
  go to 999

900 write(*,1900)
1900 format('Invalid input')

999 end program grid4_to_g15

program hashcodes

  parameter (NTOKENS=2063592)
  integer*8 nprime,n8(3)
  integer nbits(3),ihash(3)
  character*11 callsign
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/
  data nprime/47055833459_8/,nbits/10,12,22/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:    hashcodes <callsign>'
     print*,'Examples: hashcodes PJ4/K1ABC'
     print*,'          hashcodes YW18FIFA'
     go to 999
  endif
  call getarg(1,callsign)
  callsign=adjustl(callsign)

  do k=1,3
     n8(k)=0
     do i=1,11
        j=index(c,callsign(i:i)) - 1
        n8(k)=38*n8(k) + j
     enddo
     ihash(k)=ishft(nprime*n8(k),nbits(k)-64)
  enddo
  ih22_biased=ihash(3) + NTOKENS
  write(*,1000) callsign,ihash,ih22_biased
1000 format('Callsign',9x,'h10',7x,'h12',7x,'h22'/41('-')/        &
          a11,i9,2i10,/'Biased for storage in c28:',i14)

999 end program hashcodes

program gen_crc14

  character m77*77,c14*14

  integer mc(96),r(15),p(15),ncrc
! polynomial for 14-bit CRC 0x6757
  data p/1,1,0,0,1,1,1,0,1,0,1,0,1,1,1/
  
  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   gen_crc14 <77-bit message>'
     print*,'Example: gen_crc14 "00000000000000000000000000100000010011011111110011011100100010100001010000001"'
     go to 999
  endif

! pad the 77bit message out to 96 bits
  call getarg(1,m77)
  read(m77,'(77i1)') mc(1:77)
  mc(78:96)=0

! divide by polynomial
  r=mc(1:15)
  do i=0,81
    r(15)=mc(i+15)
    r=mod(r+r(1)*p,2)
    r=cshift(r,1)
  enddo

! the crc is in r(1:14) - print it in various ways:
  write(c14,'(14b1)') r(1:14)
  write(*,'(a40,1x,a14)') 'crc14 as a string: ',c14
  read(c14,'(b14.14)') ncrc
  write(*,'(a40,i6)') 'crc14 as an integer: ',ncrc
  write(*,'(a40,1x,b14.14)') 'binary representation of the integer: ',ncrc

999 end program gen_crc14
